/*------------------------------------------------------------------.
| Simple job forker (mainly because ungif is seriously "forked" off |
| without it.							    |
`------------------------------------------------------------------*/

#include <string.h>
#include <qdos.h>

void *malloc(long);

char _prog_name[] = "fork";

/*------------------------------------------------------------------.
| Attempt to determine the PROG and DATA directories: as a CStart = |
| main program, we must do this ourselves			    |
`------------------------------------------------------------------*/

void * xgetcwd(char * s)
{
    extern char *_sys_var;
    struct QLSTR **q;
    char *d = NULL;
    
    if(q = (struct QLSTR **q)(_sys_var + 0xAC))
    {
	d = s;
	for(d = s; s != d + 80; s += 40, q++)
	{
	    strncpy(s, (*q)->qs_str, (*q)->qs_strlen);
	    *(s+(*q)->qs_strlen) = 0;
	}
    }
    return d;
}

int main(int ac, char **av)
{
    char *sp, *prog, *cmd;
    short nc;
    chanid_t chid;
    int jobid, rv = -1;
    
    sp = *(av + 1);
    nc = *((short *) (sp));
    sp += 2 + nc * 4;
    nc = *((short *) sp);
    sp += 2;
    
    prog = malloc(nc+4);
    
    memcpy(prog, sp, nc); 
    *(prog + nc) = 0;
    if((cmd = strchr(prog, ' ')))
    {
	*cmd++ = 0;
    }
    
    if((rv = io_open(prog, 0)) < 0)
    {
	char *fn, *dd, fnam[40], defdirs[80];
	if(xgetcwd(defdirs))
	{
	    short j;
	    
	    for(dd = defdirs; rv < 0 && dd != defdirs+80; dd += 40)
	    {
		fn = stpcpy(fnam, dd);
		stpcpy(fn, prog); 
		rv = io_open(fnam, 0);
	    }
	}
    }

    if(rv > 0)
    {
	struct qdirect qdir;
	void *jobaddr;
	struct JOBHEADER *jh;   /* ha ha */
	long codsiz;
	short elen, nlen;
	int ch; 

	chid = rv;
	if((rv = fs_headr(chid, -1, &qdir, sizeof(qdir))) > 0)
	{
	    if(qdir.d_type == QF_PROG_TYPE)
	    {
		jobid = mt_cjob(qdir.d_length, qdir.d_datalen, NULL, -1, 
				&jobaddr);
		if(jobid > 0)
		{
		    void *stk;
		    void *tstk;
		    char *fcmd,*sptr;
		    short nc = 0;
#ifdef DEBUG
		    char *xcmd;
		    short x;
#endif
		    if((rv = fs_load(chid, jobaddr, qdir.d_length)) > 0)
		    {
			io_close(chid); chid = 0;
			jh = (((struct JOBHEADER *)jobaddr) - 1);
			stk = (void *) jh->jb_regs.jb_A7;
			if(cmd && (nlen = strlen(cmd)))
			{
			    sptr = fcmd = malloc(nlen+2);
#ifdef DEBUG
			    x = nlen;
			    xcmd = malloc(nlen+2);
			    strcpy(xcmd, cmd);
#endif
			    while (nlen--)
			    {
				if(*cmd == '.')
				{
				    *cmd = '_';
				}
				if(*cmd == '/') 
				{
				    if(*(cmd-1) == ' ' || *(cmd-1) == 0)
				    {
					*cmd++;
					nlen--;
				    }
				    else 
				    {
					*cmd = '_';
				    }
				}
				*fcmd++ = *cmd++;
				nc++;
			    }
			    *fcmd = 0;
			    elen = (nc+1) & ~1;
			}
			else
			{
			    nlen = elen = 0;
			} 

			((char *)stk) -= elen;
			(void *) jh->jb_regs.jb_A7 = stk;
			*((short *) stk)++ = 0;
			*((short *) stk)++ = nc;
			{
			    char *spc;
			    if((spc = strrchr(sptr, ' ')) == NULL)
			    {
				spc = sptr;
			    }
			    else spc++;

			    if((ch = io_open(spc, 1)) > 0)
			    {
				io_close(ch);
			    }
			    else
			    {
				char *q;
				if(q = strrchr(spc, '_')) *q = '.';
			    }
			}
			strcpy(stk, sptr);
#ifdef DEBUG
			{
			    int chn,nx;
			    char txt[80];
			    chn = io_open("win2_tmp_qf.txt", 3);
			    io_sstrg(chn, -1, (char *)sptr, nc);
			    io_sbyte(chn, -1, '\n');
			    io_sstrg(chn, -1, (char *)stk, nc);
			    io_sbyte(chn, -1, '\n');
			    io_sstrg(chn, -1, xcmd, x);
			    io_sbyte(chn, -1, '\n');
			    nx = sprintf(txt,"res = %d\n", ch);
			    io_sstrg(chn, -1, txt, nx);
			    io_close(chn);
			}
#endif
			rv = mt_activ(jobid, 8, -1);
		    }
		    else
		    {
			mt_frjob(jobid, rv);
		    }
		}
	    }
	    else
	    {
		rv = -15;
	    }
	}
	if(chid > 0)
	{
	    io_close(chid);
	}
    }
    return rv;
}

int (*_Cstart) (int, char **) = main;
